%% Plotkontroll
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Plotting av resultater, benytter funksjonene plotfunc.m, lesedata.m
% save_fig.m.
% Masteroppgave K. Stray
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
num_sim = 32; % Antall gjennomfrte simuleringer

%% Aktuelle plot
HVDC_IMPORT         = 0;
HVDC_REAKTIV        = 0;
NORGER_SPENNING     = 0;
SPENNING_VEKSEL     = 0;
GENERATORVINKLER    = 0;
VINDPARK            = 0;
NORG_WIND           = 0;
KOMPENSERING        = 0;
FREKVENS            = 0;
PRODUKSJON          = 0;
DC_CURRENT          = 0;
GAMMA               = 0;    % for identifisering av kommuteringssvikt
REAKTIV_NG          = 0;
REAKTIV_TONST       = 0;
VINDPARK_SPENNING   = 0;
GEN_VINKLER_REL     = 0;
DIV                 = 0;
if DIV == 1
    num_sim=1;
end
fig_teller=0;

for i = 1:num_sim
    %% Hovedtittel
    tittel(1) = cellstr('Masteroppgave K. Stray');
    %% Henter data
    test = lesedata(i);

    %% HVDC
    % Import (MW)
    if HVDC_IMPORT ==1
        fig_teller = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)=cellstr('Import HVDC');
        kanaler = [16,38,54,70,82];
        data = test;
        data.data(:,kanaler(length(kanaler)))=test.data(:,kanaler(length(kanaler)))/1e9; % endrer til p.u
        filer   = 1;
        y_akse  = ' P_d_c [pu.]';
        x_akse  = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    % Reaktivt forbruk
    if HVDC_REAKTIV ==1
        fig_teller = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)=cellstr('Reaktivt forbruk for HVDC');
        kanaler = [17,39,55,71,83];
        data = test;
        data.data(:,kanaler(length(kanaler)))=test.data(:,kanaler(length(kanaler)))/1e9; % endrer til p.u
        filer   = 1;
        y_akse  = ' Q_d_c [pu.]';
        x_akse  = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% NorGer og spenning
    if NORGER_SPENNING ==1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('NorGer og Spenning, fortegnsskift for import');
        if i <= num_sim/2
            kanaler     = [16,180]; % med vindpark
        else
            kanaler     = [16,175]; % uten vindpark
        end
        data        = test;
        data.data(:,kanaler(1))=test.data(:,kanaler(1))*(-1); % neg. til pos.
        filer       = 1;
        y_akse      = ' U / P_d_c [pu]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Spenning vekselretter
    if SPENNING_VEKSEL ==1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Spenning - AC-side av konvertertransformator');
        if i <= num_sim/2
            kanaler     = [166,180,202,204];
        else
            kanaler     = [161,175,193,195];
        end
        data        = test;
        filer       = 1;
        y_akse      = ' U [pu.]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Generatorvinkler
    if GENERATORVINKLER ==1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Generatorvinkler');
        if i <= num_sim/2
            kanaler     = [97,98,100,101,102,103,104];
        else
            kanaler     = [94,95, 96, 98, 99,100,101];
        end
        data        = test;
        filer       = 1;
        y_akse      = ' Rotorvinkel - \delta [ ^o]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Vindpark
    if (VINDPARK ==1 && i <= num_sim/2)
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Vindpark - Aktiv og reaktiv effekt');
        kanaler     = [284,285];
        data        = test;
        filer       = 1;
        y_akse      = ' P / Q [MW / MVAR]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% NORGER MED OG UTEN VP
    if (NORG_WIND ==1 && i<num_sim/2+1)
        % IMPORT
        fig_teller  = fig_teller + 1;
        tittel(2)   = cellstr(test.tittel);
        tittel(3)   = cellstr('NorGer import med og uten vindpark');
        kanaler     = 16;
        data        = test;
        if num_sim > 1
            data(2)     = lesedata(i+num_sim/2);
        end
        filer       = 2;
        y_akse      = ' P [pu]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Bidrag synkronkompensatorer i Feda og NorGer, samt SVC i
    %% Kristiansand
    if KOMPENSERING ==1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Bidrag synkronkompensatorer i Feda og NorGer, samt SVC i Kristiansand');
        if i <= num_sim/2
            kanaler     = [113,114,115,117];
        else
            kanaler     = [110,111,112,114];
        end
        data        = test;
        filer       = 1;
        y_akse      = ' Q [pu.]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Frekvens
    if FREKVENS ==1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Frekvensavvik i utvalgte punkter');
        if i <= num_sim/2
            kanaler     = [129,136,141,148,162,165];
        else
            kanaler     = [126,133,136,143,157,160];
        end
        data        = test;
        filer       = 1;
        y_akse      = ' Frekvensavvik [Hz]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Produksjon
    if PRODUKSJON ==1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Produksjon utvalgte enheter i omrde for produksjonstilpasning');
        if i <= num_sim/2
            kanaler     = [108,110,111,112];
        else
            kanaler     = [105,107,108,109];
        end
        data        = test;
        filer       = 1;
        y_akse      = ' P [pu.]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% DC-strm
    if DC_CURRENT == 1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('DC-strm');
        if i <= num_sim/2
            kanaler     = [24,42,58,74,78];
        else
            kanaler     = [24,42,58,74,78];
        end
        data        = test;
        data.data(:,kanaler(1))=test.data(:,kanaler(1))*1.4e3; % endrer til reell verdi, nominell DC-strm lik 1.4 kA
        filer       = 1;
        y_akse      = ' I_D_C [A]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Gamma
    if GAMMA == 1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Slukkingsvinkel');
        if i <= num_sim/2
            kanaler     = [19,44,60,76,87];
        else
            kanaler     = [19,44,60,76,87];
        end
        data        = test;
        data.data(:,kanaler(length(kanaler)))=test.data(:,kanaler(length(kanaler)))*180/pi; % endrer til grader
        filer       = 1;
        y_akse      = ' \gamma_i_n_v [ ^o ]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Reaktiv uveksling for NorGer og vindpark
    if REAKTIV_NG == 1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Reaktiv utveksling NorGer og TVP');
        if i <= num_sim/2
            kanaler     = [279,285];
        else
            kanaler     = 270;
        end
        data        = test;
        filer       = 1;
        y_akse      = ' Q [MVAR]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Reaktiv kompensering i Tonstad
    if REAKTIV_TONST == 1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Bidrag fra kompensering i Tonstad');
        if i <= num_sim/2
            kanaler     = 283;
        else
            kanaler     = 274;
        end
        data        = test;
        filer       = 1;
        y_akse      = ' Q [MVAR]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Spenning vindpark, mlt p parkekvivalentens klemmer
    if (VINDPARK_SPENNING ==1 && i <= num_sim/2)
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Klemmespenning vindparkekvivalent');
        kanaler     = 184;
        data        = test;
        filer       = 1;
        y_akse      = ' U [pu.]';
        x_akse      = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% Generatorvinkler relativ til EVAN-G3
    if GEN_VINKLER_REL ==1
        fig_teller  = fig_teller + 1;
        tittel(2)=cellstr(test.tittel);
        tittel(3)   = cellstr('Generatorvinkler relativ til EVAN-G3');
        if i <= num_sim/2
            kanaler     = [376:402,404:419];
            rel = 427;
        else
            kanaler     = [363:389,391:409];
            rel = 417;
        end
        data        = test;
        for j=1:length(kanaler)
            data.data(:,kanaler(j))=data.data(:,kanaler(j))-data.data(1,kanaler(j))-(data.data(:,rel)-data.data(1,rel));
        end
        filer       = 1;
        y_akse      = ' Rotorvinkel - \delta [ ^o]';
        x_akse      = ' t [s]';
        plotfunc2(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
    %% DIV
    if DIV ==1
        fig_teller = fig_teller + 1;
        tittel(2)=cellstr(test(i).tittel);
        tittel(3)=cellstr('Generator og ssk vinkel');
        kanaler = [104,239];
        data=test(i);
        filer   = 1;
        y_akse  = ' vinkel [pu]';
        x_akse  = ' t [s]';
        plotfunc(fig_teller,kanaler,data,tittel,x_akse,y_akse,filer,i )
    end
end
